#!/usr/bin/perl

  use CGI::Carp qw(fatalsToBrowser);
  use Time::Local ;

  require "WikiReports.pl" ;
  # use strict 'vars' ;
  # use vars qw ($false $true) ;

sub GenerateWikibookReports
{
  my ($wp,$wpc,$out_html) ;

# &GenerateWikibookReport ("en") ; # test
# return ;

  foreach $wp (@languages)
  {
# if ($wp ne "nl") { next ; } # test only, en takes long time
    if ($wp ne "zz")
    { &GenerateWikibookReport ($wp) ; }
  }

  open (WIKIBOOKS_NDX_HTML, ">", $path_out_wikibooks . "WikiBookIndex.htm") ;

  my $out_page_title    = "$out_stats_per $out_wikibook" ;
  my $out_page_subtitle = $out_index ;
  my $out_html_title    = $out_page_title ;
  my $out_explanation   = "Statistics per wikibook" ;

  if (defined ($dumpdate_hi))
  {
    $dumpdate2 = timegm (0,0,0,
                         substr ($dumpdate_hi,6,2),
                         substr ($dumpdate_hi,4,2)-1,
                         substr ($dumpdate_hi,0,4)-1900) ;
    $out_explanation = &GetDate ($dumpdate2) ;
  }

  $out_crossref = &GenerateCrossReference ("") ;

  $out_html = "" ;
  &GenerateHtmlStart ($out_html_title,  "" , "",
                      $out_page_title,  $out_page_subtitle, $out_explanation,
                      "", "", "", $out_crossref) ;

  $out_html .= "<table border=1 cellspacing=0 id=table1 style='' summary='Wiki books'>\n" ;
  foreach $wp (@languages)
  {
    if ($wp eq "zz") { next ; }

    $wpc = $wp ;
    if ($wp eq "simple")
    { $wpc = "se" ; }

    $file_wikibooks_report = "Wikibooks_" . uc($wp) . ".htm" ;
    $size = -s $path_out_wikibooks . $file_wikibooks_report ;
    if ($size > 0)
    {
      $out_size = '' ;
      if ($size > 250 * 1024)
      { $out_size = " (" . &i2KbMb ($size) . '!)' ; }
      $line_html = &tdcb ($wpc) .
                   &tdlb (&w("<a href='$file_wikibooks_report'> " . $out_languages {$wp} . "</a>$out_size")) ;
      $out_html .= &tr ($line_html) ;
    }
  }
  $out_html .= "</table>\n" ;

  &GenerateColophon ($false, $false) ;
  print WIKIBOOKS_NDX_HTML $out_html ;

  print WIKIBOOKS_NDX_HTML "</body>\n</html>\n" ;
  close WIKIBOOKS_NDX_HTML ;

  return ;

}

sub GenerateWikibookReport
{
  my $wp = shift ;

  my $file_csv_wikibooks = $path_in . "Wikibooks".uc($wp).".csv" ;
  if (! -e $file_csv_wikibooks)
  { return ; }

#  &ReadFileCsv ($file_csv_language_codes, $wp) ;
#  if ($#csv == -1)
#  { $encoding = "utf-8" ; }
#  else
#  {
#    ($dummy, $encoding) = split (',', @csv [0]) ;
#    $encoding =~ s/[\(\)]//g ;
#  }
# $encoding = "utf-8" ;
  $encoding = "iso-8859-1" ;

  my $dumpdate ;
  if (defined ($dumpdate_hi))
  {
    $dumpdate = timegm (0,0,0,
                        substr ($dumpdate_hi,6,2),
                        substr ($dumpdate_hi,4,2)-1,
                        substr ($dumpdate_hi,0,4)-1900) ;
#   $out_html_date = "<h2>" . &GetDate ($dumpdate) . "<\/h2>\n" ;
  }

  my $out_page_title    = "$out_stats_per $out_wikibook" ;
  $out_page_title =~ s/$out_wikipedia/$out_wikibook/ ;
  my $out_page_subtitle = uc ($wp) . " - <a href='" . @out_urls {$wp} . "'>" . $out_languages {$wp} . "</a>" ;
  my $out_html_title    = $out_page_title ;
  my $out_explanation   = "Wikibooks rankings and chapter lists" ;

  my $out_button_switch = "" ;
  my $out_button_home       = &btn (" " . $out_index, "WikiBookIndex.htm") ;

  $out_html = "" ;

  &GenerateHtmlStart ($out_html_title,  "" , "",
                      $out_page_title,  $out_page_subtitle, $out_explanation,
                      "", "", "&nbsp;", "") ;
  $out_script_expand2 = $out_script_expand ;
  $out_script_expand2 =~ s/WP/$wp/ ;
  $out_html =~ s/<\/head>/$out_script_expand2\n<\/head>/i ;
  $out_html =~ s/CategoryOverviewIndex/WikiBookIndex/ ; # dirty hack, cleanup !

  if ($language =~ /^(?:ja|zh)$/)
  { $out_html =~ s/(h\d\s*\{[^\}]+)(\})/$1; font-weight:normal$2/g ; }

  my $base = "http://$wp.wikibooks.org/wiki" ;

  $out_html .= "<font color=#600000>This overview is experimental. At the present there are no strict rules for article naming on wikibooks. " .
               "As a result the division<br>of article titles into book name and chapter name in the following report is not and can't be perfect. " .
               "See also used <a href='#algorithm'>algorithm</a> below.</font>" ;
  if ($wp eq "en")
  {
    $out_html .= "<p>Non English books which have been moved to another wikibook site and " .
                 "for which only the history is kept here are not shown.<br>" .
                 "There are still quite many books that should be moved and a template similar to " .
                 "<a href='http://en.wikibooks.org/wiki/Template:Bereits_nach_de.wikibooks.org_verschoben'>this notice</a> should be added. " ;
  }
  $out_html .= "<hr>" ;

  $out_html .= "\@LISTS\@" ;
  $out_html .= "<hr><hr>" ;
  $out_html .= "\@TOC\@" ;

  open (WIKIBOOKS_CSV, "<", $file_csv_wikibooks) ;
  @books = <WIKIBOOKS_CSV> ;
  close (WIKIBOOKS_CSV) ;

  if ($#books < 10)
  {
    $file_wikibooks_report = $path_out_wikibooks . "Wikibooks_" . uc($wp) . ".htm" ;
    unlink $file_wikibooks_report ;
    return ;
  }

  @books = sort { &csvkey_chapters ($b) <=> &csvkey_chapters ($a)} @books ;

  # $out_html .= "<p><hr><p><h3>Books with more than one chapter</h3>" ;
  $prev_parts = 0 ;
  $idnamebook = 1 ;
  $indexcnt = 0 ;
  undef @url_chapters ;
  undef %hrefbook ;
  undef %tocbook ;
  foreach my $line (@books)
  {
    undef %chapter_urls ;

    if ($line =~ /^\#/) { next ; } # comment
    chomp ($line) ;
    $line =~ s/^\|// ;
    $line =~ s^\#\*\$\@^'^g ; # restore single quotes (shoul already be done in count job)
    $line =~ s^\\\"^\"^g ;
    my ($book, $parts, $edits, $size, $words, $authors, $chapterlist) = split (',', $line) ;

    $book     =~ s/&pipe;/\|/g ;
    $book     =~ s/&comma;/\,/g ;
    $book     =~ s/&star;/\*/g ;

    # &Log2 ("== Book '$book' ==\n\n") ;

    @chapters = split ('\|', $chapterlist) ;

    $href= "" ;
    @hrefbook {$book} = ++$idnamebook ;
    $href = "<a id='$idnamebook' name='$idnamebook'></a>" ;
    if (($size > 10*1024) && ($parts > 1))
    {
      $indexcnt++ ;
      @tocbook {$book} = $idnamebook ;
    }

    foreach $chapter (@chapters)
    {
      $chapter =~ s/&pipe;/\|/g ;
      $chapter =~ s/&comma;/\,/g ;
      ($chapter,$link) = split ('\*', $chapter) ;
      $chapter =~ s/^[\_\:\/\-]+// ;
      $chapter =~ s/[\_\:\/\-]+$// ;
      $chapter =~ s/&star;/\*/g ;
      $link    =~ s/&star;/\*/g ;
      @chapter_urls {$chapter} = $link ;
    }

    if ($parts == 1)
    {
      $chapter = @chapters [0] ;
      $chapter2 = $chapter ;
      $chapter2 =~ s/_/ /g ;
      $chapter2 =~ s/^[\:\_\-\/]+// ;
      $url_chapter = &EncodeURL ("$base/" . @chapter_urls {$chapter}) ;
      $book =~ s/\_/&nbsp;/g ;
      push @url_chapters, "$href<a href='$url_chapter'>" . &EncodeHtml (&ConvertUnicode ($book)) . "</a> &#47; \n";
      $prev_parts = 1 ;
      next ;
    }

    $url_book = '' ;
    if (@chapter_urls {$book} ne '')
    {
      $url_book = &EncodeURL ("$base/" . @chapter_urls {$book}) ;
      $book =~ s/\_/&nbsp;/g ;
      $link_book = "<a href='$url_book'>" . &EncodeHtml (&ConvertUnicode ($book)) . "</a>" ;
      $out_html .= "<hr>$href<p><h4>$link_book</h4>$parts chapters, $edits edits, size " .
                   &i2KbMb($size) . ", $words words<p>" ;
    }
    else
    {
      $book =~ s/\_/&nbsp;/g ;
      $out_html .= "<hr>$href<p><h4>" . &EncodeHtml (&ConvertUnicode ($book)) . "</h4>$parts chapters, $edits edits, size " .
                   &i2KbMb($size) . ", $words words<p>" ;
    }
    $line_html  = "" ;
    $line_html2 = "b2(\"$book\");\n" ;

    @chapters = sort {csvkey_chapter($a) cmp csvkey_chapter($b)} @chapters ;

    $book =~ s/&comma;/\,/g ;
    $book2 = $book ;
    $book2 =~ s/_/ /g ;

    &FindSubBooks ;
    &WriteChapters ($base) ;

#   $out_html  .= $line_html2 ;
    $out_html .= "\n<script>\n$line_html2</script>\n\n" ;
  }

  $out_html .= "<p><hr><p><b>Remainder (books that seemingly are not divided into chapters)</b><p>" ;
  foreach $line_html (sort {$a cmp $b} @url_chapters)
  { $out_html  .= $line_html ; }

  $line_html = '' ;
  $charprev  = "" ;
  if ($indexcnt > 10)
  {
    $line_html = "<p><h4>Alphabetical Index</h4>Books larger than 10 Kb and more than one chapter:<p>" ;
    foreach $book (sort {$a cmp $b} keys %tocbook)
    {
      $book2 = $book ;
      $book2 =~ s/_/ /g ;
      $char = substr ($book2,0,1) ;
      if ($char ne $charprev)
      {

        $line_html .= "&nbsp;<br><font size='+1'><b>$char</b></font>&nbsp;\n" ;
        $charprev = $char ;
      }
      else
      { $line_html .= " &#47; " ; }

      $line_html .= "<a href='\#" . @tocbook {$book} . "'>" . &EncodeHtml (&ConvertUnicode ($book2)) . "</a>\n" ;
    }
    $line_html .= "<hr>" ;
  }

  $out_html =~ s/\@TOC\@/$line_html/ ;

  my $listmax = 100 ;
  if ($listmax > ($#books + 1))
  { $listmax = $#books + 1 ; }

  $out_lists = "" ;
  $out_lists .= "<table border=0 cellspacing=5 style=''><tr><td>\n" ;
  @books = sort { &csvkey_size ($b) <=> &csvkey_size ($a)} @books ;
  &ListBooksOrderedBy ('size in bytes', $listmax, 3) ;
  $out_lists .= "</td><td>\n" ;
  @books = sort { &csvkey_edits ($b) <=> &csvkey_edits ($a)} @books ;
  &ListBooksOrderedBy ('number of edits', $listmax, 2) ;
  $out_lists .= "</td><td>\n" ;
  @books = sort { &csvkey_authors ($b) <=> &csvkey_authors ($a)} @books ;
  &ListBooksOrderedBy ('number of authors', $listmax, 5) ;
  $out_lists .= "</td><td>\n" ;
  @books = sort { &csvkey_chapters ($b) <=> &csvkey_chapters ($a)} @books ;
  &ListBooksOrderedBy ('number of chapters', $listmax, 1) ;
  $out_lists .= "</td></tr></table><p>" ;

  $out_html =~ s/\@LISTS\@/$out_lists/ ;

#  $out_html .= "<hr><p><small>Category tags that were inserted via a template are <b>not yet</b> recognised." .
#              "<br>Also this overview may lists categories pages that only contain a redirect tag.</small>" ;

  $out_html .= "<p><hr><p><a name=algorithm></a><font color=#600000>" .
               "This overview is experimental.<br>" .
               "Algorithm used to detect book titles is roughly this:<p>" .
               "On a first pass through the input, article titles are scanned for candidate book and chapter names as follows:<br>".
               "Find the first colon, forward slash and hyphen. Whichever of these comes first determines division between book and chapter title.<br>" .
               "If none of these are found treat text between brackets as chapter title, rest as book title.<br>" .
               "If no brackets are found and the article title ends with one or more digits, assume this is a numbered chapter.<br>" .
               "If none of the above applies, treat first space as divison between book and chapter title.<p>" .
               "On a second pass book titles that occurred less than three times are marked as possible false positives<br>" .
               "Article titles which match exactly a candidate book name that occurs more than twice, are added to the selection<br>" .
               "(these are introductory pages, first chapters, or how you want to call them)<br> " .
               "Counts are now collected.<p>" .
               "Before writing the report, books are further divided into 'subbooks' and single chapters, using almost the same algorithm as above,<br>" .
               "except that now subbook titles without colon, slash, hyphen, bracket or trailing digit are matched for the longest text <br>" .
               "that occurs several times within one book</font>"  ;

  &GenerateColophon ($false, $false) ;

  if ($language =~ /^(?:ja|zh)$/)
  { $out_html =~ s/<\/?b>//g ; }

  $file_wikibooks_report = $path_out_wikibooks . "Wikibooks_" . uc($wp) . ".htm" ;
  open (WIKIBOOKS_REPORT, ">", $file_wikibooks_report) ;
  print WIKIBOOKS_REPORT $out_html ;
  close WIKIBOOKS_REPORT ;
}

sub ListBooksOrderedBy
{
  my $order = shift ;
  my $max   = shift ;
  my $ndx   = shift ;

  $out_lists .= "<table border=1 cellspacing=0 id='table1' style=''  summary='$max largest books ordered by $order'>\n" ;
  $out_lists .= "<tr><th colspan='2' align=left class=l>$max books ordered by $order</th></tr>\n" ;
  $linecnt = 0 ;
  foreach my $line (@books)
  {
    if ($line =~ /^\#/) { next ; } # comment
    chomp ($line) ;
    if (++$linecnt > $max) { last ; }

    $line =~ s/^\|// ;
    $line =~ s^\#\*\$\@^'^g ; # restore single quotes (shoul already be done in count job)
    $line =~ s^\\\"^\"^g ;
    my (@fields) = split (',', $line) ;
    $book = @fields [0] ;
    $book =~ s/&pipe;/\|/g ;
    $book =~ s/&comma;/\,/g ;
    $book =~ s/&star;/\*/g ;

    $link_book = "<a href='\#" . @hrefbook {$book} . "'>" . &EncodeHtml (&ConvertUnicode ($book)) . "</a>\n" ;
    $out_lists .= &tr (&tdr (&i2KM (@fields[$ndx])) . &tdl($link_book)) ;
  }
  $out_lists .= "</table><p>" ;
}

sub FindSubBooks
{
  my ($chapter, $booktitle) ;

  undef %booktitles ;
  undef %booktitles2 ;
  undef %book ;
  undef %showchapter ;

  for (my $pass = 1 ; $pass <= 2 ; $pass++)
  {
    foreach $chapter (@chapters)
    {
      $chapter2   = $chapter ;
      # $chapter2   =~ s/^[\:\_\-\/]+// ;
      $booktitle = $chapter2 ;

      $title_found = $true ;

      $poscolon   = index ($chapter2, ':') ;
      $posslash   = index ($chapter2, '/') ;
      $poshyphen  = index ($chapter2, '_-_') ;
      if ($poshyphen == -1)
      { $poshyphen  = index ($chapter2, '-') ; }
      $posbracket = index ($chapter2, '(') ;
      $posspace   = index ($chapter2, '_') ;
      # $posspace   = index (substr ($chapter2,4), '_') + 4 ;

      $posnum = -1 ;
      if ($chapter2 =~ /\_?\d+$/)
      {
        $chapter3 = $chapter2 ;
        $chapter3 =~ s/\_?\d+$// ;
        $posnum = length ($chapter3) ;
      }

      $poscolon   = ($poscolon   < 1 ? 9999 : $poscolon) ;
      $posslash   = ($posslash   < 2 ? 9999 : $posslash) ;
      $poshyphen  = ($poshyphen  < 2 ? 9999 : $poshyphen) ;
      $posbracket = ($posbracket < 2 ? 9999 : $posbracket) ;
      $posnum     = ($posnum     < 2 ? 9999 : $posnum) ;
      $posspace   = ($posspace   < 1 ? 9999 : $posspace) ;

       # &Log2 ("\nChapter $pass '$chapter2'\n") ;
       # &Log2 ("colon $poscolon slash $posslash hyphen $poshyphen bracket $posbracket num $posnum space $posspace\n") ;

      if (($poscolon < 9999) && ($poscolon < $posslash) && ($poscolon < $poshyphen))
      {
        $booktitle =~ s/\:.*$// ;
        $chapter2   = substr ($chapter2, length ($booktitle)) ;
      }
      elsif (($posslash < 9999) && ($posslash < $poscolon) && ($posslash < $poshyphen))
      {
        $booktitle =~ s/\/.*$// ;
        $chapter2   = substr ($chapter2, length ($booktitle)) ;
      }
      elsif (($poshyphen < 9999) && ($poshyphen < $poscolon) && ($poshyphen < $posslash))
      {
        $booktitle =~ s/\_?\-.*$// ;
        $chapter2  = substr ($chapter2, length ($booktitle)) ;
      }
      elsif ($posbracket < 9999)
      {
        # if ($pass == 1)
        # { &Log2 ("posbracket $posbracket $chapter\n") ; }
        $booktitle =~ s/^.*\(([^\)]+)\).*$/$1/ ;
        $chapter2  =~ s/^(.*)\([^\)]+\)(.*)$/$1 $2/ ;
        # if ($pass == 1)
        # { &Log2 ("'$booktitle' '$chapter2'\n") ; }
      }
      elsif ($posnum < 9999)
      {
        # if ($pass == 1)
        # { &Log2 ("posnum $posnum $chapter\n") ; }
        $booktitle = substr ($chapter2, 0, $posnum)  ;
        $chapter2  = substr ($chapter2, $posnum) ;
        # if ($pass == 1)
        # { &Log2 ("'$booktitle' '$chapter2'\n") ; }
      }
      elsif ($posspace < 9999)
      {
        # &Log2 ("\n\nPosSpace '$booktitle'\n") ;
        my @words = split ('\_', $booktitle) ;
        $booktitle = shift (@words) ;
        # &Log2 ("Booktitle '$booktitle'\n") ;
        while ($#words >= 0)
        {
          my $matches = 0 ;
          $testtitle = $booktitle . '_' . shift (@words) ;
          # &Log2 ("Testtitle '$testtitle'\n") ;
          foreach $testchapter (@chapters)
          {
            if (substr ($testchapter, 0, length ($testtitle)) eq $testtitle)
            {
              # &Log2 ("Match with '$testchapter'\n") ;
              $matches ++ ;
              if ($matches > 2) { last ; }
            }
          }
          # &Log2 ("Matches '$matches'\n") ;
          if ($matches < 2) { last ; }
          $booktitle = $testtitle ;

        }
        if ($booktitle =~ /^[\_\:\/\-]*(?:the|an|of|le|la|les|un|une|de|des|du|een|het|ein|eine|das|die)[\_\:\/\-]*$/i)
        { $booktitle = $chapter2 ; }
        else
        { $chapter2  = substr ($chapter2, length ($booktitle)) ; }
        # &Log2 ("Booktitle '$booktitle' Chapter '$chapter2'\n") ;
      }
      else
      {
        $booktitle   = $chapter2 ;
        $title_found = $false ;
      }

      $booktitle =~ s/^[\_\:\/\-]+// ;
      $booktitle =~ s/[\_\:\/\-]+$// ;

      if ($pass == 1)
      {
        @booktitles {$booktitle} ++ ;
        next ;
      }

      if (@booktitles {$chapter} >= 2)
      {
        $booktitle = $chapter ;
        $chapter2  = $chapter ;
      }

      @booktitles2 {$booktitle} ++ ;
      @book        {$chapter} = $booktitle ;
      @showchapter {$chapter} = $chapter2 ;
    }
  }

  foreach $chapter (@chapters)
  {
    if (@booktitles2 {@book {$chapter}} == 1)
    {
      @book        {$chapter} = chr(255) ;
      @showchapter {$chapter} = $chapter ;
    }
    else
    {
      if (@showchapter {$chapter} eq $chapter)
      { @showchapter {$chapter} = 'Idem' ; }
    }

    @showchapter {$chapter} =~ s/^[\_\:\/\-]+// ;
    @showchapter {$chapter} =~ s/[\_\:\/\-]+$// ;
  }

  @chapters = sort { @book {$a} cmp @book {$b}} @chapters ;

  foreach $chapter (@chapters)
  {
    if (@book {$chapter} eq chr(255))
    { @book {$chapter} = '' ; }
    # &Log2 ("book " . @book {$chapter} . ": chapter: " . @showchapter {$chapter} . "\n") ;
  }
}

sub WriteChapters
{
  my $base = shift ;
  my $subbook ;
  my $subbookprev = '' ;
  my $url_subbook = '' ;

  foreach my $chapter (@chapters)
  {
    $subbook = @book {$chapter} ;
    if ($subbook ne $subbookprev)
    {
      # $line_html2 =~ s/\&[^\&]*$/<br>/ ;
      $line_html2 =~ s/\|$/\");\n/ ;
      if ($subbook ne '')
      {
        # $line_html .= "<img src='../bookshelf.gif' alt='Book shelf'>" ;
        if (@showchapter {$subbook} eq "Idem")
        {
          $url_subbook = &EncodeURL ("$base/" . @chapter_urls {$subbook}) ;
          $subbook2 = $subbook ;
          $subbook2 =~ s/\_/&nbsp;/g ;
          # $line_html2 .= "<a href='$url_subbook'><b>" . &EncodeHtml (&ConvertUnicode ($subbook2)) . "</b></a>&nbsp;&nbsp; " ;
          $line_html2 .= "\n\nhl(\"$subbook\");\nc(\"" ;
        }
        else
        {
          $subbook2 = $subbook ;
          $subbook2 =~ s/\_/&nbsp;/g ;
          # $line_html2 .= "<b>" . &EncodeHtml (&ConvertUnicode ($subbook2)) . "</b>&nbsp;&nbsp; " ;
          $line_html2 .= "\nh(\"$subbook\");\nc(\"" ;
        }
      }
      else
      # { $line_html2 .= "<br>" ; }
      { $line_html2 .= "hr();\nc(\"" ; }
    }
    $subbookprev = $subbook ;

#   if ($line_html2 !~ /\|$/)
#   { $line_html2 .= "c(\"" ; }

    $url_chapter = &EncodeURL ("$base/" . @chapter_urls {$chapter}) ;

    if ($url_chapter eq $url_book) { next ; }
    if ($url_chapter eq $url_subbook) { next ; }

    $chapter = @showchapter {$chapter} ;
    $chapter =~ s/&pipe;/\|/g ;
    $chapter =~ s/&comma;/\,/g ;
    $chapter =~ s/\_/ /g ;
    $prefix = '-' ;
    if (($chapter eq 'Idem'|| ($subbook eq '')))
    { $prefix = '' ; }
    # $line_html2 .= "<a href='$url_chapter'>$prefix" . &EncodeHtml (&ConvertUnicode ($chapter)) . "</a> &#47; " ;
    $url_chapter =~ s/^.*?\/wiki\/// ;
    $url_chapter =~ s/\%20/ /g ;
#    print "book [$book2] [$subbook] [$url_chapter]\n" ;

#    $url_chapter =~ s/([^\w\\])/\\$1/g ;
#    $book2       =~ s/([^\w\\])/\\$1/g ;
#    $subbook     =~ s/([^\w]\\)/\\$1/g ;
#    $chapter     =~ s/([^\w]\\)/\\$1/g ;

#    $url_chapter =~ s/$book2/^0^/g ;
##    $url_chapter =~ s/$subbook/^1^/g ;
#    $url_chapter =~ s/$chapter/^2^/g ;

#    $url_chapter =~ s/\\([^\w\\])/$1/g ;
#    $book2       =~ s/\\([^\w\\])/$1/g ;
#    $subbook     =~ s/\\([^\w\\])/$1/g ;
#    $chapter     =~ s/\\([^\w\\])/$1/g ;

#    print "     [$book2] [$subbook]  [$url_chapter]\n" ;
    $url_chapter =~ s/ /_/g ;
    $chapter     =~ s/\_/&nbsp;/g ;
    $line_html2 .= "$url_chapter`$chapter|" ;
  }
  $line_html2 =~ s/\|$/\");\n/ ;
# $line_html2 =~ s/\&[^\&]*$// ;
}

1;
